﻿/* Bomber Class for Kaboom
 * 
 * This class represents the moving computer controlled bomber in the game.
 * The bomber moves randomly from side to side and drops bombs.  As the game advances,
 * difficulty increase.  This is achieved by increasing the bomber's movement speed and
 * decreasing the time it takes for him to drop bombs.
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Kaboom
{
    class Bomber: Microsoft.Xna.Framework.DrawableGameComponent
    {
        // bomber properties
        protected Texture2D texture;  // bomber image
        protected Rectangle spriteRectangle;  // bomber area
        protected Vector2 position;  // bomber position
        protected int levelSpeed;  // difficulty factor for the speed of the bomber
        protected int Xspeed;  // speed on the x-axis
        protected Random random;

        // Width and height of sprite in texture
        protected const int BOMBERWIDTH = 83;
        protected const int BOMBERHEIGHT = 134;

        // time values
        private  int ADDBOMBTIME = 500;
        private int lastTickCount;

        // Bomber constructor
        public Bomber(Game game, ref Texture2D theTexture)
            : base(game)
        {

            texture = theTexture;
            position = new Vector2();

            // create the source rectangle
            // This represents where the sprite picture is in the surface
            
            spriteRectangle = new Rectangle(0, 0, BOMBERWIDTH, BOMBERHEIGHT);
            
            // initialize the random number generator and put the bomber in its start position
            
            random = new Random(this.GetHashCode());
            PutinStartPosition();

        }
        /// <summary>
        /// Initialize Bomb position and velocity
        /// </summary>
        public void PutinStartPosition()
        {
            position.X = 400- BOMBERWIDTH;
            position.Y = 0;
           
            Xspeed =  - 2;
        }

        /// <summary>
        /// Allows the game component to draw your content in the game screen
        /// </summary>
        public override void Draw(GameTime gameTime)
        {
            // Get the current sprite batch
            SpriteBatch sBatch = (SpriteBatch)Game.Services.GetService(typeof(SpriteBatch));

            // Draw the Bomb
            sBatch.Draw(texture, position, spriteRectangle, Color.White);

            base.Draw(gameTime);
        }

        /// <summary>
        /// Initialize the bomber
        /// </summary>
        public override void Initialize()
        {          

            base.Initialize();

            levelSpeed = 2;
        }

        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // check if the bomber is still visible        
         
            // Move BOMBER
           // position.Y += Yspeed;
           position.X += Xspeed*2;

           if ((position.X >= 800 - BOMBERWIDTH) || (position.X <= 0))
           {

               Xspeed = Xspeed * -1;
           }
            
           CheckforNewBomb();
            base.Update(gameTime);
        }

        // returns the bombers coordinate on the x-axis
        public float xCoordinate() {
            return position.X;
        }

        /// <summary>
        /// Checks if it is time for the bomber to drop the next bomb
        /// </summary>
        private void CheckforNewBomb()
        {
            
            if ((System.Environment.TickCount - lastTickCount) > ADDBOMBTIME)
            {
                lastTickCount = System.Environment.TickCount;
                int randomNumber = random.Next(2);
                if (randomNumber == 1)
                {
                    Xspeed = levelSpeed * -1;

                }
                else if (randomNumber == 0)
                {

                    Xspeed = levelSpeed;
                } 
            }
        }

        // increase the game level, which increases game difficulty
        public  void goTonextLevel() {
            levelSpeed +=1;
            ADDBOMBTIME =ADDBOMBTIME- 20;
            position.X = 400 - BOMBERWIDTH;
            position.Y = 0;
        }

        // reset the game difficulty
        public void reset() {
            levelSpeed = 2;
            ADDBOMBTIME = 500;
        }

    }
}
